Cost Calculator
============
(https://rdmepfl.github.io/costcalc/)

## Introduction

The cost calculator is an online project for calculating the cost of services. It's originally designed for helping researcher for estimating the cost of managing data. The user can calculate the cost of the data life cycle directly from the interface.

Categories, Providers, Cost can be easily updated by just changing the **data.js** so it can be adapted for your own institution.


## How to use it

The structure is highly modular and can be extended for different projects. 
All the information are stored on javascript and the system only uses javascript 
libraries making really easy to install and update.

You don't need a specific webserver (but you can use one), just use your github repo 
and create a pages link your cost calculator will be accessible

## Documentation

The documentation of the project explains how to install it and configure it. See [Docs](./Docs)

## Files/Folders

* All the engine is stored in the **js** folder
* index.html : main index for production
* **docs** contains the documentation for changing the database of provider or the engine itself.
* __index-dev.html__ : Index file for development only
*  __index-pres.html__ : Index file for presentation only


## Citation
The project is hosted on Zenodo : [![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.1469034.svg)](https://doi.org/10.5281/zenodo.1469034)

The citation information are in the __CITATION__ file and __CODEMETA.json__.

## License and Term of Usage

This project is release under GNuv3 license see __LICENSE__.

It's a work of the Research Data Management Team at EPFL Library in Switzerland.
